package gov.nih.nci.coppa.services.pa.studysiteservice.client;

import gov.nih.nci.coppa.common.LimitOffset;
import gov.nih.nci.coppa.services.pa.Id;
import gov.nih.nci.coppa.services.pa.StudySite;
import gov.nih.nci.coppa.services.pa.studysiteservice.common.StudySiteServiceI;
import gov.nih.nci.pa.iso.util.IiConverter;

import java.rmi.RemoteException;

import org.apache.axis.client.Stub;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.globus.gsi.GlobusCredential;

/**
 * This class is autogenerated, DO NOT EDIT GENERATED GRID SERVICE ACCESS METHODS.
 *
 * This client is generated automatically by Introduce to provide a clean unwrapped API to the
 * service.
 *
 * On construction the class instance will contact the remote service and retrieve it's security
 * metadata description which it will use to configure the Stub specifically for each method call.
 *
 * @created by Introduce Toolkit version 1.3
 */
public class StudySiteServiceClient extends StudySiteServiceClientBase implements StudySiteServiceI {

    private static String protocolExtention = "27426";
    private static String siteExtention = "27471";
    public StudySiteServiceClient(String url) throws MalformedURIException, RemoteException {
        this(url,null);
    }

    public StudySiteServiceClient(String url, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(url,proxy);
    }

    public StudySiteServiceClient(EndpointReferenceType epr) throws MalformedURIException, RemoteException {
           this(epr,null);
    }

    public StudySiteServiceClient(EndpointReferenceType epr, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(epr,proxy);
    }

    public static void usage(){
        System.out.println(StudySiteServiceClient.class.getName() + " -url <service url>");
    }

    public static void main(String [] args){
        System.out.println("Running the Grid Service Client");
        try{
        if(!(args.length < 2)){
            if(args[0].equals("-url")){
              StudySiteServiceClient client = new StudySiteServiceClient(args[1]);
              // place client calls here if you want to use this main as a
              // test....
              getById(client);
              getByStudyProtocol(client);
              search(client);
            } else {
                usage();
                System.exit(1);
            }
        } else {
            usage();
            System.exit(1);
        }
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    private static void getByStudyProtocol(StudySiteServiceClient client) throws RemoteException {
        Id id = new Id();
        id.setRoot(IiConverter.STUDY_PROTOCOL_ROOT);
        id.setIdentifierName(IiConverter.STUDY_PROTOCOL_IDENTIFIER_NAME);
        id.setExtension(protocolExtention);
        StudySite[] stCont = client.getByStudyProtocol(id);
        System.out.println("get by study protocol brought back set sized " + stCont.length);
    }

    private static void getById(StudySiteServiceClient client) throws RemoteException {
        Id id = new Id();
        id.setExtension(siteExtention);
        id.setRoot(IiConverter.STUDY_SITE_ROOT);
        id.setIdentifierName(IiConverter.STUDY_SITE_IDENTIFIER_NAME);
        StudySite stCont = client.get(id);
        if (stCont == null) {
            System.out.println("could not find StudySite");
        } else {
            System.out.println("StudySite found = " + siteExtention);
        }
        System.out.println(ToStringBuilder.reflectionToString(stCont, ToStringStyle.MULTI_LINE_STYLE));
    }

    private static void search(StudySiteServiceClient client) throws RemoteException {
        StudySite sp = new StudySite();

        LimitOffset limit = new LimitOffset();
        limit.setLimit(10);
        limit.setOffset(0);
        StudySite[] results = client.search(sp, limit);
        System.out.println("search found " + results.length + " study site objects based on source study site");
        for (int i = 0; i < results.length; i++) {
            System.out.println(ToStringBuilder.reflectionToString(results[i], ToStringStyle.MULTI_LINE_STYLE));
        }
    }
    

  public void copy(gov.nih.nci.coppa.services.pa.Id fromStudyProtocolId,gov.nih.nci.coppa.services.pa.Id toStudyProtocolId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"copy");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CopyRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CopyRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CopyRequestFromStudyProtocolId fromStudyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CopyRequestFromStudyProtocolId();
    fromStudyProtocolIdContainer.setId(fromStudyProtocolId);
    params.setFromStudyProtocolId(fromStudyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CopyRequestToStudyProtocolId toStudyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CopyRequestToStudyProtocolId();
    toStudyProtocolIdContainer.setId(toStudyProtocolId);
    params.setToStudyProtocolId(toStudyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CopyResponse boxedResult = portType.copy(params);
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySite create(gov.nih.nci.coppa.services.pa.StudySite studySite) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"create");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CreateRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CreateRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CreateRequestStudySite studySiteContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CreateRequestStudySite();
    studySiteContainer.setStudySite(studySite);
    params.setStudySite(studySiteContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.CreateResponse boxedResult = portType.create(params);
    return boxedResult.getStudySite();
    }
  }

  public void delete(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"delete");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.DeleteRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.DeleteRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.DeleteRequestId idContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.DeleteRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.DeleteResponse boxedResult = portType.delete(params);
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySite get(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"get");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetRequestId idContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetResponse boxedResult = portType.get(params);
    return boxedResult.getStudySite();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySite[] getByStudyProtocol(gov.nih.nci.coppa.services.pa.Id studyProtocolId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudyProtocol");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolRequestStudyProtocolId studyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolRequestStudyProtocolId();
    studyProtocolIdContainer.setId(studyProtocolId);
    params.setStudyProtocolId(studyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolResponse boxedResult = portType.getByStudyProtocol(params);
    return boxedResult.getStudySite();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySite[] getByStudyProtocolAndRole(gov.nih.nci.coppa.services.pa.Id studyProtocolId,gov.nih.nci.coppa.services.pa.StudySite studySite) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudyProtocolAndRole");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRoleRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRoleRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRoleRequestStudyProtocolId studyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRoleRequestStudyProtocolId();
    studyProtocolIdContainer.setId(studyProtocolId);
    params.setStudyProtocolId(studyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRoleRequestStudySite studySiteContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRoleRequestStudySite();
    studySiteContainer.setStudySite(studySite);
    params.setStudySite(studySiteContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRoleResponse boxedResult = portType.getByStudyProtocolAndRole(params);
    return boxedResult.getStudySite();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySite[] getByStudyProtocolAndRoles(gov.nih.nci.coppa.services.pa.Id studyProtocolId,gov.nih.nci.coppa.services.pa.StudySite[] studySite) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudyProtocolAndRoles");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRolesRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRolesRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRolesRequestStudyProtocolId studyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRolesRequestStudyProtocolId();
    studyProtocolIdContainer.setId(studyProtocolId);
    params.setStudyProtocolId(studyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRolesRequestStudySite studySiteContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRolesRequestStudySite();
    studySiteContainer.setStudySite(studySite);
    params.setStudySite(studySiteContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.GetByStudyProtocolAndRolesResponse boxedResult = portType.getByStudyProtocolAndRoles(params);
    return boxedResult.getStudySite();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySite update(gov.nih.nci.coppa.services.pa.StudySite studySite) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"update");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.UpdateRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.UpdateRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.UpdateRequestStudySite studySiteContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.UpdateRequestStudySite();
    studySiteContainer.setStudySite(studySite);
    params.setStudySite(studySiteContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.UpdateResponse boxedResult = portType.update(params);
    return boxedResult.getStudySite();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySite[] search(gov.nih.nci.coppa.services.pa.StudySite studySite,gov.nih.nci.coppa.common.LimitOffset limitOffset) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault, gov.nih.nci.coppa.common.faults.TooManyResultsFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"search");
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.SearchRequest params = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.SearchRequest();
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.SearchRequestStudySite studySiteContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.SearchRequestStudySite();
    studySiteContainer.setStudySite(studySite);
    params.setStudySite(studySiteContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.SearchRequestLimitOffset limitOffsetContainer = new gov.nih.nci.coppa.services.pa.studysiteservice.stubs.SearchRequestLimitOffset();
    limitOffsetContainer.setLimitOffset(limitOffset);
    params.setLimitOffset(limitOffsetContainer);
    gov.nih.nci.coppa.services.pa.studysiteservice.stubs.SearchResponse boxedResult = portType.search(params);
    return boxedResult.getStudySite();
    }
  }

}
